import itertools
import math

def calculate_distance(p1, p2):
    return abs(p1[0] - p2[0]) + abs(p1[1] - p2[1])

def tsp(points):
    n = len(points)
    # Создаем матрицу расстояний
    dist = [[0] * n for _ in range(n)]
    
    for i in range(n):
        for j in range(n):
            if i != j:
                dist[i][j] = calculate_distance(points[i], points[j])
    
    # Динамическое программирование с использованием масок
    dp = [[float('inf')] * n for _ in range(1 << n)]
    
    # Начинаем с первого адреса
    for i in range(n):
        dp[1 << i][i] = 0
    
    # Заполнение таблицы dp
    for mask in range(1 << n):
        for u in range(n):
            if mask & (1 << u) == 0:
                continue
            for v in range(n):
                if mask & (1 << v) != 0:
                    continue
                new_mask = mask | (1 << v)
                dp[new_mask][v] = min(dp[new_mask][v], dp[mask][u] + dist[u][v])
    
    # Находим минимальный маршрут, возвращаясь в начальную точку
    min_cost = float('inf')
    for u in range(n):
        min_cost = min(min_cost, dp[(1 << n) - 1][u] + dist[u][0])
    
    return min_cost

# Чтение входных данных
n = int(input())
points = [tuple(map(int, input().strip().split())) for _ in range(n)]

# Вычисление минимального маршрута
result = tsp(points)

# Вывод результата
print(f"{result:.6f}")
import itertools
import math

def calculate_distance(p1, p2):
    return abs(p1[0] - p2[0]) + abs(p1[1] - p2[1])

def tsp(points):
    n = len(points)
    # Создаем матрицу расстояний
    dist = [[0] * n for _ in range(n)]
    
    for i in range(n):
        for j in range(n):
            if i != j:
                dist[i][j] = calculate_distance(points[i], points[j])
    
    # Динамическое программирование с использованием масок
    dp = [[float('inf')] * n for _ in range(1 << n)]
    
    # Начинаем с первого адреса
    for i in range(n):
        dp[1 << i][i] = 0
    
    # Заполнение таблицы dp
    for mask in range(1 << n):
        for u in range(n):
            if mask & (1 << u) == 0:
                continue
            for v in range(n):
                if mask & (1 << v) != 0:
                    continue
                new_mask = mask | (1 << v)
                dp[new_mask][v] = min(dp[new_mask][v], dp[mask][u] + dist[u][v])
    
    # Находим минимальный маршрут, возвращаясь в начальную точку
    min_cost = float('inf')
    for u in range(n):
        min_cost = min(min_cost, dp[(1 << n) - 1][u] + dist[u][0])
    
    return min_cost

# Чтение входных данных
n = int(input())
points = [tuple(map(int, input().strip().split())) for _ in range(n)]

# Вычисление минимального маршрута
result = tsp(points)

# Вывод результата
print(f"{result:.6f}")
